package it.unibo.tw0708.web;

import it.unibo.tw0809.utils.MyValidator;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Another servlet
 *
 * @author you
 */
public class ServletSolution 
extends HttpServlet {
	
	private static final long serialVersionUID = -7822739649809280754L;

	/**
	 * This servlet forwards the request processing of HTTP POST requests
	 * to the method handling HTTP GET ones.
	 * This way, the servlet can be invoked by submitting both request types
	 */
	public void doPost(HttpServletRequest request,
            HttpServletResponse response)
    throws IOException, ServletException {
    	this.doGet(request,response);
    }

	/**
	 * Requests are served by invoking library functions
	 * and returning html-wrapped results 
	 */
    @SuppressWarnings("unchecked")
	public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    	
    	ArrayList<String> lista = (ArrayList<String>) request.getSession().getAttribute("lista");
    	if ( lista == null )
    		lista = new ArrayList<String>();
    	request.getSession().setAttribute("lista", lista);
    	
    	String data = request.getParameter("data");
    	String schema_uri = super.getServletContext().getInitParameter("schemaLocation");

    	// actual validation
    	if ( MyValidator.validate(data, schema_uri) )
    		lista.add( data );

    	// this is where we are gonna write html results
        PrintWriter out = response.getWriter();

        out.println("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>");
        out.println();
        out.println("<collection>");
        for ( String item : lista )
        	out.println(item);
        out.println("</collection>");
    }

}