package it.unibo.tw0809.test;

import static org.junit.Assert.*;
import it.unibo.tw0809.utils.FileUtil;
import it.unibo.tw0809.utils.MyValidator;

import org.junit.Test;

public class MyValidatorTest {

	@Test
	public void testValidateOk() {
		String xml = FileUtil.readFile("war/resources/compactdisc-ok.xml");
		assertTrue("Validation ok", MyValidator.validate(xml, "http://localhost:8080/DoItYourSelf/resources/compactdisc.xsd"));
	}

	@Test
	public void testValidateKo() {
		String xml = FileUtil.readFile("war/resources/compactdisc-ko.xml");
		assertFalse("Validation ko", MyValidator.validate(xml, "http://localhost:8080/DoItYourSelf/resources/compactdisc.xsd"));
	}

	@Test
	public void testValidateNoNamespace() {
		String xml = FileUtil.readFile("war/resources/compactdisc-noNamespace.xml");
		assertFalse("Validation without namespace declaration fails", MyValidator.validate(xml, "http://localhost:8080/DoItYourSelf/resources/compactdisc.xsd"));
		System.out.println("ATTENZIONE!!!!!!");
		System.out.println("Occorre dichiarare il nome del namespace nell'elemento radice del file XML!!!!");
	}

	String template_xml = "<compactdisc xmlns=\"http://localhost:8080/DoItYourSelf/CompactDisc\">\t<author>Queen</author>\t<album year=\"1992\">Greatest Hits II</album></compactdisc>";

	@Test
	public void testCompareString() {
		String file_xml = FileUtil.readFile("war/resources/compactdisc-ok.xml");
		assertEquals("Same length: " + template_xml.length(), template_xml.length(), file_xml.length());
		for ( int i = 0 ; i < file_xml.length() ; i++ ) {
			assertEquals("Match for character at position: " + i, template_xml.charAt(i), file_xml.charAt(i));
		}
	}

	@Test
	public void testValidateString() {
		assertTrue("Validation ok", MyValidator.validate(template_xml, "http://localhost:8080/DoItYourSelf/resources/compactdisc.xsd"));
	}

}
