function leggiAttributo(item, nomeNodo, nomeAttributo) {
	// breakpoint here and inspect with debug what nodes we have
	var nomeNodoElement = item.getElementsByTagName(nomeNodo).item(0);
	var nomeNodoElementFirstChild = nomeNodoElement.firstChild;
	return nomeNodoElement.getAttribute(nomeAttributo);
};


function leggiContenuto(item, nomeNodo) {
	return item.getElementsByTagName(nomeNodo).item(0).firstChild.nodeValue;
};


function applicaContenuto( theXML, theElement ) {
	var theHTML = 
		"<p>" +
			"<table><caption>I miei CD</caption>" +
			"<thead><tr><th>Artista</th><th>Album</th><th>Anno</th></th></thead>";
	
	var compactdiscs = theXML.getElementsByTagName("compactdisc");
	
	// Predisponiamo una struttura dati in cui memorrizzare le informazioni di interesse
	var itemNodes = new Array();

	// ciclo di lettura degli elementi
	for (    var a = 0, b = compactdiscs.length;    a < b;   a++   ) {
		// [length al posto di push serve per evitare errori con vecchi browser]
		itemNodes[a] = new Object();
		itemNodes[a].author = leggiContenuto(compactdiscs[a],"author");
		itemNodes[a].album = leggiContenuto(compactdiscs[a],"album");
		itemNodes[a].year = leggiAttributo(compactdiscs[a],"album", "year");
	}// for ( items )

	//	"<tr><td>Queen</td><td>Greatest Hits I</td><td>1981</td></tr>
	for( var c = 0; c < itemNodes.length; c++ ) {
		theHTML += '<tr><td>'+itemNodes[c].author+'</td><td>'+itemNodes[c].album+'</td><td>'+itemNodes[c].year+'</td></tr>';
	};

	theHTML += "</table></p>";
	theElement.innerHTML = theHTML;
}

/*
 * Funzione di callback
 */
function callback( theXhr, theElement ) {

	// designiamo la formattazione della zona dell'output
	theElement.class = "content";
	
	// verifica dello stato
	if ( theXhr.readyState === 2 ) {
	    	theElement.innerHTML = "Richiesta inviata...";
	}// if 2
	else if ( theXhr.readyState === 3 ) {
    		theElement.innerHTML = "Ricezione della risposta...";
	}// if 3
	else if ( theXhr.readyState === 4 ) {

		// verifica della risposta da parte del server
	        if ( theXhr.status === 200 ) {

	        	// operazione avvenuta con successo
			if ( theXhr.responseXML ) {
		        applicaContenuto(theXhr.responseXML, theElement);
			}// if XML

			else {
			        // visualizzazione contenuto letto
			        // evitando di scrivere la risposta in modo
			        // interpretabile dal browser
        			theElement.innerHTML = "L'XML restituito dalla richiesta non è valido.<br />" +
				theXhr.responseText.split('<').join("&lt;").split('>').join("&gt;");
			}// else (if ! XML)

	        }// if 200

	        else {
	        	// errore di caricamento
	        	theElement.innerHTML = "Impossibile effettuare l'operazione richiesta.<br />";
	        	theElement.innerHTML += "Errore riscontrato: " + theXhr.statusText;
	        }// else (if ! 200)

	}// if 4

} // callback();



/*
 * Imposta il contenuto disponibile presso theUri
 * come src di un iframe all'interno dell'elemento theHolder del DOM
 * Non usa AJAX; per browser legacy
 */
function caricaContenutoIframe(theUri,theHolder,data) {
	// qui faccio scaricare al browser direttamente il contenuto del feed come src dell'iframe.
	theHolder.innerHTML = '<iframe src="' + theUri + '?data=' + '" width="50%" height="50px">Il tuo browser non supporta gli iframe</iframe>';
	// non riesco tuttavia a intervenire per parsarlo! è il browser che renderizza l'src dell'iframe!
}// caricaContenutoIframe()



/*
 * Imposta il contenuto xml disponibile presso theUri
 * all'interno dell'elemento theHolder del DOM
 * Usa tecniche AJAX attrverso la XmlHttpRequest fornita in theXhr
 */
function caricaContenutoAJAX(theUri, theElement, theXhr, data) {
    
	// impostazione controllo e stato della richiesta
	theXhr.onreadystatechange = function() { callback(theXhr, theElement); };

	// impostazione richiesta asincrona in POST!!
	// del file specificato
	try {
		theXhr.open("post", theUri, true);
	}
	catch(e) {
		// Exceptions are raised when trying to access cross-domain URIs 
		alert(e);
	}

	// rimozione dell'header "connection" come "keep alive"
	theXhr.setRequestHeader("connection", "close");

	// impostazione dell'header per descrivere il contenuto in post
	theXhr.setRequestHeader( "content-type", "application/x-www-form-urlencoded" );

	// invio richiesta
	theXhr.send("data="+escape(data));

} // caricaContenutoAJAX()



/*
 * Scarica un contenuto xml dall'uri fornito
 * e lo aggiunge al contenuto dell'elemento e del dom
 * Gestisce sia AJAX che il mancato supporto ad AJAX 
 */
function caricaContenuto(uri,e,data) {

	// variabili di funzione
	var
		// assegnazione oggetto XMLHttpRequest
		xhr = myGetXmlHttpRequest();

	if ( xhr ) 
		caricaContenutoAJAX(uri,e,xhr,data); 
	else 
		caricaContenutoIframe(uri,e,data); 

}// caricaContenuto()




function invocaServlet() {
	var fields = document.getElementsByTagName('form')[0].childNodes;
	var author, album, year;
	for ( var i = 0 ; i < fields.length ; i++ ) {
		if ( fields[i].name == "author")
			author = fields[i].value;
		if ( fields[i].name == "album")
			album = fields[i].value;
		if ( fields[i].name == "year")
			year = fields[i].value;
	}
	var uri = "servletSolution";
	var data = 
		'<compactdisc xmlns="http://localhost:8080/DoItYourSelf/CompactDisc">' +
		'<author>'+author+'</author>' +
		'<album year="'+year+'">'+album+'</album>' +
		'</compactdisc>';
	var target = myGetElementById("istruzioni");
	caricaContenuto(uri,target,data);
}