function applicaContenuto( theMsg, theElement ) {
	theElement.innerHTML = theMsg;
}

/*
 * Funzione di callback
 */
function callback( theXhr, theElement ) {

	// designiamo la formattazione della zona dell'output
	theElement.class = "content";
	
	// verifica dello stato
	if ( theXhr.readyState === 2 ) {
	    	theElement.innerHTML = "Richiesta inviata...";
	}// if 2
	else if ( theXhr.readyState === 3 ) {
    		theElement.innerHTML = "Ricezione della risposta...";
	}// if 3
	else if ( theXhr.readyState === 4 ) {

		// verifica della risposta da parte del server
	        if ( theXhr.status === 200 ) {

	        	// operazione avvenuta con successo
			if ( theXhr.responseXML ) {
		        applicaContenuto("Risposta ricevuta con successo", theElement);
			}// if XML

			else {
		        applicaContenuto("Risposta ricevuta con successo", theElement);
			}// else (if ! XML)

	        }// if 200

	        else {
	        	// errore di caricamento
	        	theElement.innerHTML = "Impossibile effettuare l'operazione richiesta.<br />";
	        	theElement.innerHTML += "Errore riscontrato: " + theXhr.statusText;
	        }// else (if ! 200)

	}// if 4

} // callback();



/*
 * Imposta il contenuto disponibile presso theUri
 * come src di un iframe all'interno dell'elemento theHolder del DOM
 * Non usa AJAX; per browser legacy
 */
function caricaContenutoIframe(theUri,theHolder,data) {
	// qui faccio scaricare al browser direttamente il contenuto del feed come src dell'iframe.
	theHolder.innerHTML = '<iframe src="' + theUri + '?data=' + '" width="50%" height="50px">Il tuo browser non supporta gli iframe</iframe>';
	// non riesco tuttavia a intervenire per parsarlo! è il browser che renderizza l'src dell'iframe!
}// caricaContenutoIframe()



/*
 * Imposta il contenuto xml disponibile presso theUri
 * all'interno dell'elemento theHolder del DOM
 * Usa tecniche AJAX attrverso la XmlHttpRequest fornita in theXhr
 */
function caricaContenutoAJAX(theUri, theElement, theXhr, data) {
    
	// impostazione controllo e stato della richiesta
	theXhr.onreadystatechange = function() { callback(theXhr, theElement); };

	// impostazione richiesta asincrona in POST!!
	// del file specificato
	try {
		theXhr.open("post", theUri, true);
	}
	catch(e) {
		// Exceptions are raised when trying to access cross-domain URIs 
		alert(e);
	}

	// rimozione dell'header "connection" come "keep alive"
	theXhr.setRequestHeader("connection", "close");

	// impostazione dell'header per descrivere il contenuto in post
	theXhr.setRequestHeader( "content-type", "application/x-www-form-urlencoded" );

	// invio richiesta
	theXhr.send("data="+escape(data));

} // caricaContenutoAJAX()



/*
 * Scarica un contenuto xml dall'uri fornito
 * e lo aggiunge al contenuto dell'elemento e del dom
 * Gestisce sia AJAX che il mancato supporto ad AJAX 
 */
function caricaContenuto(uri,e,data) {

	// variabili di funzione
	var
		// assegnazione oggetto XMLHttpRequest
		xhr = myGetXmlHttpRequest();

	if ( xhr ) 
		caricaContenutoAJAX(uri,e,xhr,data); 
	else 
		caricaContenutoIframe(uri,e,data); 

}// caricaContenuto()




function invocaServlet() {
	var fields = document.getElementsByTagName('form')[0].childNodes;
	var author, album, year;
	for ( var i = 0 ; i < fields.length ; i++ ) {
		if ( fields[i].name == "author")
			author = fields[i].value;
		if ( fields[i].name == "album")
			album = fields[i].value;
		if ( fields[i].name == "year")
			year = fields[i].value;
	}
	var uri = "servletPartialSolution";
	var data = 
		'<compactdisc xmlns="http://localhost:8080/DoItYourSelf/CompactDisc">' +
		'<author>'+author+'</author>' +
		'<album year="'+year+'">'+album+'</album>' +
		'</compactdisc>';
	var target = myGetElementById("partial");
	caricaContenuto(uri,target,data);
}